#include "Calculator.h"

#include <iostream>
#include <sstream> //Needed for std::ostringstream
using namespace std;

//Class Constructor
Calculator::Calculator() :
    //Inizialize class members
    PrecValue(0),
    Value(0),
    DotInserted(false),
    Op(NONE),
    InsertedCharacters(0),
    stream(),
    sign(POSITIVE),
    IsFirstAlreadyReplaced(false),
    ResultOutputted(false)
    {
    //Create the window
    Window.Create(sf::VideoMode(520,520,32), "SFML Calculator", sf::Style::Close, sf::WindowSettings(24,8));

    //Create the display
    Display.first=sf::Shape::Rectangle(50,50,470,100,sf::Color(255,255,255,255),3.f,sf::Color(0,0,0,255)); /* Create a rectangle which goes from (50,50)
                                                                                                            * to (470, 100). Its color is white (all
                                                                                                            * RGBA values are 255), and has a black outline
                                                                                                            * of 3px width
                                                                                                            */
    Display.second.SetText("0"); //Current text in the display
    Display.second.SetSize(40); //Text is 40px height
    Display.second.SetCenter(Display.second.GetRect().GetWidth(), Display.second.GetRect().GetHeight()/2);
    Display.second.SetPosition(445,70); //Set the position of the text in the display
    Display.second.SetColor(sf::Color(0,0,0,255)); //The text is black
    //Same as before
    SignString.SetText("+");
    SignString.SetSize(40);
    SignString.SetCenter(0, SignString.GetRect().GetHeight()/2);
    SignString.SetPosition(70,70);
    SignString.SetColor(sf::Color(0,0,0,255));

    //Numbers' buttons
    for (short i=0; i<12; ++i) {
        RegularButtons.push_back(std::pair<sf::Shape, sf::String>()); //Create a new buttons
        //Set buttons' coordinates
        int x1=50+(i%3)*90, x2=x1+60, y1=150+i/3*90, y2=y1+60;
        RegularButtons.back().first=sf::Shape::Rectangle(x1,y1,x2,y2,sf::Color(100,100,100),2,sf::Color(0,0,0,255));
        //Set buttons' text
        std::string button_text;
        switch (i) {
            case 0: button_text="7"; break;
            case 1: button_text="8"; break;
            case 2: button_text="9"; break;
            case 3: button_text="4"; break;
            case 4: button_text="5"; break;
            case 5: button_text="6"; break;
            case 6: button_text="1"; break;
            case 7: button_text="2"; break;
            case 8: button_text="3"; break;
            case 9: button_text="+/-"; break;
            case 10: button_text="0"; break;
            case 11: button_text="."; break;
            default: break;
        }
        RegularButtons.back().second.SetText(button_text);
        RegularButtons.back().second.SetSize(30);
        RegularButtons.back().second.SetCenter(RegularButtons.back().second.GetRect().GetWidth()/2, RegularButtons.back().second.GetRect().GetHeight()/2); //Center the writing
        RegularButtons.back().second.SetPosition(80+90*(i%3), 180+90*(i/3));
    }
    //+,-,*,/
    for (short i=0; i<4; ++i) {
        OpButtons.push_back(std::pair<sf::Shape, sf::String>());
        int x1=320, x2=x1+60, y1=150+i*90, y2=y1+60;
        OpButtons.back().first=sf::Shape::Rectangle(x1,y1,x2,y2,sf::Color(200,150,0),2,sf::Color(0,0,0));
        std::string button_text;
        switch (i) {
            case 0: button_text="+"; break;
            case 1: button_text="-"; break;
            case 2: button_text="x"; break;
            case 3: button_text="/"; break;
            default: break;
        }
        OpButtons.back().second.SetText(button_text);
        OpButtons.back().second.SetSize(30);
        OpButtons.back().second.SetCenter(OpButtons.back().second.GetRect().GetWidth()/2, OpButtons.back().second.GetRect().GetHeight()/2);
        OpButtons.back().second.SetPosition(350, 180+90*i);
    }
    //Clear, Equal
    for (short i=0; i<2; ++i) {
        ExButtons.push_back(std::pair<sf::Shape, sf::String>());
        int x1=410, x2=x1+60, y1=150+i*180, y2=y1+150;
        ExButtons.back().first=sf::Shape::Rectangle(x1,y1,x2,y2,sf::Color(255,50,0),2,sf::Color(0,0,0));
        if (i==0) ExButtons.back().second.SetText("C"); //Clear button
        else ExButtons.back().second.SetText("=");
        ExButtons.back().second.SetSize(30);
        ExButtons.back().second.SetCenter(ExButtons.back().second.GetRect().GetWidth()/2, ExButtons.back().second.GetRect().GetHeight()/2);
        ExButtons.back().second.SetPosition(440, 225+i*180);
    }
}

Calculator::~Calculator() {
    //Nothing to do
}

void Calculator::Start() {
    sf::Event Event; //Event handler
    bool Running=true; //Has the calculator go on running, or do we have to quit?
    while (Running) { //While we have to run
        while (Window.GetEvent(Event)) { //Read the events (key presses, mouse clicks, etc.)
            switch (Event.Type) { //What happened? (A key has been pressed, X has been hit, etc.
                case sf::Event::Closed: //Red X or Alt+F4 pressed
                    Running=false; break; //Quit
                case sf::Event::MouseButtonPressed: {//Mouse click (only with left button)
                    int x=Event.MouseButton.X;
                    int y=Event.MouseButton.Y; //Mouse position
                    //Check if a button has been pressed, and eventually elaborate it
                    if (x>=50 && x<=110) {
                        if (y>=150 && y<=210) InsertCharacter(SEVEN);
                        else if (y>=240 && y<=300) InsertCharacter(FOUR);
                        else if (y>=330 && y<=390) InsertCharacter(ONE);
                        else if (y>=420 && y<=480) InsertCharacter(SWAP_SIGN);
                    }
                    else if (x>=140 && x<=200) {
                        if (y>=150 && y<=210)  InsertCharacter(EIGHT);
                        else if (y>=240 && y<=300) InsertCharacter(FIVE);
                        else if (y>=330 && y<=390) InsertCharacter(TWO);
                        else if (y>=420 && y<=480) InsertCharacter(ZERO);
                    }
                    else if (x>=230 && x<=290) {
                        if (y>=150 && y<=210)  InsertCharacter(NINE);
                        else if (y>=240 && y<=300) InsertCharacter(SIX);
                        else if (y>=330 && y<=390) InsertCharacter(THREE);
                        else if (y>=420 && y<=480) InsertCharacter(INSERT_DOT);
                    }
                    else if (x>=320 && x<=380) {
                        if (y>=150 && y<=210)  InsertCharacter(PLUS);
                        else if (y>=240 && y<=300) InsertCharacter(MINUS);
                        else if (y>=330 && y<=390) InsertCharacter(PER);
                        else if (y>=420 && y<=480) InsertCharacter(SOLIDUS);
                    }
                    else if (x>=410 && x<=470) {
                        if (y>=150 && y<=300) InsertCharacter(CLEAR);
                        else if (y>=330 && y<=480) InsertCharacter(EQUAL);
                    }
                } //MouseClick
                break;
                case sf::Event::KeyPressed: { //Input by keyborad
                    switch (Event.Key.Code) {
                        case '1': InsertCharacter(ONE); break;
                        case '2': InsertCharacter(TWO); break;
                        case '3': InsertCharacter(THREE); break;
                        case '4': InsertCharacter(FOUR); break;
                        case '5': InsertCharacter(FIVE); break;
                        case '6': InsertCharacter(SIX); break;
                        case '7': InsertCharacter(SEVEN); break;
                        case '8': InsertCharacter(EIGHT); break;
                        case '9': InsertCharacter(NINE); break;
                        case '0': InsertCharacter(ZERO); break;
                        case sf::Key::Code::Period: case sf::Key::Code::Comma : InsertCharacter(INSERT_DOT); break;
                        case sf::Key::Code::PageUp: case sf::Key::Code::PageDown: case sf::Key::Code::Home: case sf::Key::Code::End: InsertCharacter(SWAP_SIGN); break;
                        case sf::Key::Code::Add: InsertCharacter(PLUS); break;
                        case sf::Key::Code::Subtract: InsertCharacter(MINUS); break;
                        case sf::Key::Code::Multiply: InsertCharacter(PER); break;
                        case sf::Key::Code::Divide: InsertCharacter(SOLIDUS); break;
                        case sf::Key::Code::Equal: case sf::Key::Code::Return: InsertCharacter(EQUAL); break;
                        default: break;
                    }
                } //KeyPressed
                break;
                default: break;
            } //Switch event.type
        } //Event Loop

        //Drawing
        Window.Clear(sf::Color(50,50,250,255));
        for (unsigned i=0; i<RegularButtons.size(); ++i) {
            Window.Draw(RegularButtons[i].first);
            Window.Draw(RegularButtons[i].second);
        }
        for (unsigned i=0; i<OpButtons.size(); ++i) {
            Window.Draw(OpButtons[i].first);
            Window.Draw(OpButtons[i].second);
        }
        for (unsigned i=0; i<ExButtons.size(); ++i) {
            Window.Draw(ExButtons[i].first);
            Window.Draw(ExButtons[i].second);
        }
        Window.Draw(Display.first);

        ///String processing
        Window.Draw(SignString);
        Display.second.SetText(stream.str());
        Display.second.SetCenter(Display.second.GetRect().GetWidth(), Display.second.GetRect().GetHeight()/2);
        Window.Draw(Display.second);

        Window.Display(); //Display window content
        sf::Sleep(0.0166); //Wait a bit, avoid huge CPU usage
    } //While Running
}

void Calculator::InsertCharacter(ButtonCode bc) {
    //Checks which button has been pressed
    switch (bc) {
        break;
        case ZERO:
        case ONE:
        case TWO:
        case THREE:
        case FOUR:
        case FIVE:
        case SIX:
        case SEVEN:
        case EIGHT:
        case NINE: {
            if (!ResultOutputted) {
                if (Op==NONE || IsFirstAlreadyReplaced) {
                    if (InsertedCharacters<15) {
                        stream<<bc;
                        ++InsertedCharacters;
                    }
                }
                else if (Op!=NONE && !(IsFirstAlreadyReplaced)) {
                    PrecValue=double(atof(stream.str().c_str()))*sign;
                    Value=0;
                    DotInserted=false;
                    InsertedCharacters=0;
                    IsFirstAlreadyReplaced=true;
                    sign=POSITIVE;
                    SignString.SetText("+");
                    stream.str("");
                    stream<<bc;
                    ++InsertedCharacters;
                }
            }
        }
        break;
        case SWAP_SIGN: {
            if (!ResultOutputted) {
                if (sign==POSITIVE) {
                    sign=NEGATIVE;
                    SignString.SetText("-");
                }
                else {
                    sign=POSITIVE;
                    SignString.SetText("+");
                }
            }
        }
        break;
        case INSERT_DOT: {
            if (!ResultOutputted) {
                if (!DotInserted && InsertedCharacters>0 && InsertedCharacters<15) {
                    DotInserted=true;
                    ++InsertedCharacters;
                    stream<<".";
                }
            }
        }
        break;
        case PLUS:
        case MINUS:
        case  PER:
        case SOLIDUS: {
            if (!IsFirstAlreadyReplaced && !ResultOutputted && InsertedCharacters>0 && !ResultOutputted) {
                PrecValue=double(atof(stream.str().c_str()));
                Op=static_cast<Operator>(static_cast<int>(bc));
            }
        }
        break;
        case CLEAR:
            PrecValue=0;
            Value=0;
            DotInserted=false;
            InsertedCharacters=0;
            IsFirstAlreadyReplaced=false;
            sign=POSITIVE;
            SignString.SetText("+");
            stream.str("");
            ResultOutputted=false;
            break;
        case EQUAL: {
            if (!ResultOutputted) {
                Value=double(atof(stream.str().c_str()))*sign;
                long double result(0);
                stream.str("");
                switch (Op) {
                    case ADD: result=PrecValue+Value; break;
                    case SUBTRACT: result=PrecValue-Value; break;
                    case MULTIPLY: result=PrecValue*Value; break;
                    case DIVIDE:
                        if (Value==0) {
                            (PrecValue==0) ? stream<<"Undetermined" : stream<<"Impossible";
                        }
                        else
                            result=PrecValue/Value;
                        break;
                    default: break;
                }
                if (Op==DIVIDE && Value==0) { //We don't have to show the sign
                    SignString.SetText("");
                }
                else { //Show regular result
                    if (result>=0) SignString.SetText("+");
                    else SignString.SetText("-");

                    stream<<fabsf(result); //Absolute value
                }
                ResultOutputted=true;
                Op=NONE;
            }
        }
        break;
        default: break;
    }
}
